package TreeSnatcher.Core;

import java.awt.AWTException;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Shape;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import javax.imageio.ImageIO;

import TreeSnatcher.GUI.DebugFrame;
import TreeSnatcher.GUI.ImageBuffer;
import TreeSnatcher.GUI.Wizard;

public class TextRecognizer 
{
	private Robot robot;
	private Process p;
	private String res;
	private ImageOperations iops;
	private Wizard wiz;
	private ImageBuffer ib;
	
	public TextRecognizer(ImageOperations iops, Wizard wiz, ImageBuffer ib)
	{
		this.iops = iops;
		this.wiz = wiz;
		this.ib = ib;
		/*
		try 
		{
			robot = new Robot();
		} 
		catch (AWTException e) 
		{
		}
		*/
	}
	
	public String getText(Rectangle bb)
	{
		BufferedImage srcImage = ib.getSourceImage();
		BufferedImage image = srcImage.getSubimage(bb.x, bb.y, bb.width, bb.height);
		//BufferedImage image = robot.createScreenCapture(boundingBox);
		BufferedImage grImage = iops.convertToGreyscale(image, wiz.greyscaleFactors);
		//BufferedImage scImage = iops.resizeImageWithHint(srcImage, BufferedImage.TYPE_INT_ARGB); 
		//BufferedImage shImage = iops.sharpenUSM(image, null, 1, 1.0);
		//new DebugFrame(grImage, "");
		
		File f = new File("image.png");

		try 
		{
			ImageIO.write(grImage, "png", f);
		} 
		catch (IOException e) {}
		
		try 
		{
			/*
			p = Runtime.getRuntime().exec("nconvert -out ppm -o " + "image.ppm " + "image.png");
			p.waitFor();
			p.destroy();
			//p = Runtime.getRuntime().exec("gocr " + "image.ppm");
			*/
			p = Runtime.getRuntime().exec("gocr -v 4 -m 4, -e gocrOutput.txt " + "image.png");
			p.waitFor();
			res = null;
			if (p.getInputStream().available() > 0) res = inputStreamAsStrings(p.getInputStream());
			
		} 
		catch (InterruptedException e) {}
		catch (IOException e) {};
		
		image.flush();
		grImage.flush();
		
		return res;
	}
	
	public String inputStreamAsStrings(InputStream stream) throws IOException
	{
		String text = "";
		BufferedReader br = new BufferedReader(new InputStreamReader(stream));
		String line = "";
		while ((line = br.readLine()) != null) text = text + line + "\n";
		br.close();
		return text;
	}
	
}
